/*
*	HTTPDIGEST - MD5 challenge/response authentication (RFC2069 and RFC2617)
*
*	Ref: /sys/src/cmd/auth/factotum/httpdigest.c
*
*	-Kenar-
*/
#include "httpdigest.h"

static void
strtolower(char *s)
{
	while(*s){
		*s = tolower(*s);
		s++;
	}
}

void
authdig1(char *user, char *realm, char *passwd, char *ha1)
{
	DigestState *s;
	uchar b[MD5dlen];
	/*
	 *  H(A1) = MD5(uid + ":" + realm ":" + passwd)
	 */
	s = md5((uchar*)user, strlen(user), nil, nil);
	md5((uchar*)":", 1, nil, s);
	md5((uchar*)realm, strlen(realm), nil, s);
	md5((uchar*)":", 1, nil, s);
	md5((uchar*)passwd, strlen(passwd), b, s);
	enc16(ha1, sizeof(ha1), b, MD5dlen);
	strtolower(ha1);


}


void
authdig2(char *ha1, char *nonce, char *method, char *uri, char *dig)
{
	uchar b[MD5dlen];
	char ha2[MD5dlen*2+1];
	DigestState *s;

	/*
	 *  H(A2) = MD5(method + ":" + uri)
	 */
	s = md5((uchar*)method, strlen(method), nil, nil);
	md5((uchar*)":", 1, nil, s);
	md5((uchar*)uri, strlen(uri), b, s);
	enc16(ha2, sizeof(ha2), b, MD5dlen);
	strtolower(ha2);

	/*
	 *  digest = MD5(H(A1) + ":" + nonce + ":" + H(A2))
	 */
	s = md5((uchar*)ha1, MD5dlen*2, nil, nil);
	md5((uchar*)":", 1, nil, s);
	md5((uchar*)nonce, strlen(nonce), nil, s);
	md5((uchar*)":", 1, nil, s);
	md5((uchar*)ha2, MD5dlen*2, b, s);
	enc16(dig, MD5dlen*2+1, b, MD5dlen);
	strtolower(dig);
}

#ifdef nodef
void
main(int argc, char **argv)
{
	char dig[MD5dlen*2+1];
	char *user, *realm,*passwd,*nonce,*method,*uri;
	user="arisawa";
	realm="/~arisawa/";
	passwd="blackcat";
	nonce="b51f5a608f751a26919b917e";
	method="GET";
	uri="/~arisawa/";
	digest(user, realm, passwd,nonce, method, uri,dig);
	print("%s\n", dig);
	/* the result is the response that should be
	   8f18d2bfa5c3dc8bae1c1eb5ebcdaf5d  */
}
#endif
